alarm_handle: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    BTFSC	state_reg, TEMP_OVER			; if (ovt) GOTO alarm1
    GOTO	overflow_temp_alarm1
    GOTO	no_overflow_temp_alarm1			; else GOTO no_alarm1
overflow_temp_alarm1:
    MOVLW	(.2 * tall)				; if (temp < tal) ovt = 0
    SUBWF	temp,W
    BTFSS	STATUS,C
    BCF		state_reg, TEMP_OVER
    GOTO	overflow_temp_alarm1_end
no_overflow_temp_alarm1:
    MOVLW	(.2 * talh)				; if (temp > tah) ovt = 1
    SUBWF	temp,W
    BTFSC	STATUS,C
    BSF		state_reg, TEMP_OVER
    GOTO	overflow_temp_alarm1_end
overflow_temp_alarm1_end:

alarm_hw_procedure: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    BTFSC	state_reg, TEMP_OVER
    GOTO	alarm_hw_proc
    BTFSS	state_reg, MATCH_DSID_FLAG
    GOTO	alarm_hw_proc
    BTFSS	state_reg, MATCH_CRC_FLAG
    GOTO	alarm_hw_proc
    BCF		state_reg, ALARM_ON
    GOTO	alarm_handle_ret
alarm_hw_proc:
    BSF		state_reg, ALARM_ON
    GOTO	alarm_handle_ret
    
output_procedure: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    BTFSC	state_reg, ALARM_ON
    GOTO	output_set_alarm
    ClearAlarmPin
    GOTO	output_procedure_ret
output_set_alarm:
    SetAlarmPin
    GOTO	output_procedure_ret    